#ifndef _BAR_H_
#define _BAR_H_

#include "custwind.h"

_CLASSDEF(TBarWindows)
class _EXPORT TBarWindows : virtual public TUnderlying
{
public:
	TBarWindows(PCustColors SomeColors, PCustCursors
		SomeCursors)
		: TUnderlying(SomeColors, SomeCursors)
		{ };

   //Only need to draw the frame and title
	virtual void UserFrame(HDC DrawDC);
	virtual void UserTitle(HDC DrawDC);

protected:
	virtual LPSTR GetClassName()
		{ return (LPSTR)"BARWINDOW"; };
};

/*******************************************************************
The following will create two new classes, one to create
Dialogs and the Other for Windows.  This isn't hard to
do because the major chunk can just be cut from the
CUSTWIND.H header file and change the names.
*******************************************************************/

_CLASSDEF(TBarDialog)
class TBarDialog : public TCustomDialog,
	public TBarWindows
{
public:
	TBarDialog(PTWindowsObject AParent, LPSTR AName,
		PCustColors Colors, PCustCursors Cursors,
		PTModule AModule = NULL)
		: TCustomDialog(AParent, AName, Colors, Cursors,
      	AModule) ,
		 TBarWindows(Colors, Cursors),
		 TUnderlying(Colors, Cursors) {};
	TBarDialog(PTWindowsObject AParent, int ResourceId,
		PCustColors Colors, PCustCursors Cursors,
		PTModule AModule = NULL)
		: TBarWindows(Colors, Cursors),
		 TUnderlying(Colors, Cursors),
		 TCustomDialog(AParent, ResourceId, Colors, Cursors,
      	AModule) { };
};

_CLASSDEF(TBarWindow)
class TBarWindow : public TCustomWindow,
	public TBarWindows
{
public:
	TBarWindow(PTWindowsObject AParent, LPSTR ATitle,
		PCustColors Colors, PCustCursors Cursors,
		PTModule AModule = NULL)
		: TCustomWindow(AParent, ATitle, Colors, Cursors,
			AModule),
		TUnderlying(Colors, Cursors),
		TBarWindows(Colors, Cursors) {};
};


#endif //_BAR_H_

